<?php

$map_path="c:/ms4w_develop/Apache/htdocs/maps/";

  /* set up the session */
include ("Common.php");
include ("Utilities.php");
include ("C:/ms4w_develop/Apache/htdocs/fusion-jx3/common/php/Utilities.php");

function saveToExcel($results, $fieldList)
{
	error_reporting(E_ALL);

	/** PHPExcel */
	require_once 'PHPExcel.php';
	
	/** PHPExcel_IOFactory */
	require_once 'PHPExcel/IOFactory.php';
	
	// Create new PHPExcel object
	$objPHPExcel = new PHPExcel();
	
	// Set properties
	$objPHPExcel->getProperties()->setCreator("GASH - EBSD")
								 ->setLastModifiedBy("GASH - EBSD")
								 ->setTitle("EBSD query results")
								 ->setDescription("Results of the last run query");
	
	$worksheet = $objPHPExcel->getSheet(0);
	$i=0;
	foreach ($fieldList as $fieldName) {
		$worksheet->setCellValueByColumnAndRow($i,1, $fieldName);
		$objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($i,1)->getFont()->setBold(true);
		$i++;
	}
	

	$y=2;
	foreach($results as $row)
	{
		$x=0;	
		foreach($row as $cell)
		{
			if($x>0) $worksheet->setCellValueByColumnAndRow($x,$y, $cell);

			$x++;
		}
		
		$y++;
	}
	$objPHPExcel->setActiveSheetIndex(0);
	$objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
	$objWriter->save(getSessionSavePath() . "query_results.xls");

	
}
 
function getPgsqlResult($selectString, $fromString, $whereString,$oLayer,$oMap)
{

	
	$str = explode("_", $fromString);
	$singleTable = substr($str[0], 0, strlen($str[0]) - 1);
	$selectString =  preg_replace("/\./","_",$selectString);
	$whereString =  preg_replace("/\./","_",$whereString);
		// Connecting, selecting database

	$dbconn = pg_connect("host=andorra.nitg.tno.nl dbname=GashDatabase_test user=tom password=thedbpassword")
		or die('Could not connect: ' . pg_last_error());

// Performing SQL query
	$query = "SELECT $selectString FROM $fromString WHERE $whereString ";
	

	
/*	$file="checkSelectString.txt";
	$fh = fopen($file, "w");
	fwrite($fh, $query);
	fclose($fh);*/
	$result = pg_query($query) or die('Query failed: ' . pg_last_error());
	$fieldNamesList=array();
	$rowList=array();
	$numOfFields = pg_num_fields($result);
	$fieldNamesList[] ='';
	for($i=0; $i<$numOfFields; $i++)
	{
		$fieldName = pg_field_name($result, $i);		
		if($fieldName != "loc_x" && $fieldName != "loc_y") $fieldNamesList[] = str_replace("pct", "%", str_replace ("_"," ", $fieldName));
	} 

	while ($line = pg_fetch_assoc($result)) {	
		$rowData= array();
		
   	    $rowData[] = insertZoomLink($line,$oLayer,$oMap);
	    foreach ($line as $fieldName => $col_value) {

	    	if($fieldName != "loc_x" && $fieldName != "loc_y") 
			{
				if(is_null($col_value))
				{
					$rowData[]= "(null)";
				}
				else
				{
					$rowData[]= "$col_value";
				}
			}
	    }
		$rowList[]=$rowData;
	    $idContainer[]=$line["wells_well_id"];
	}
//	fclose($fh);
//	$file="output.txt";
//	$fh = fopen($file, "w");
//	fwrite($fh,"\n------------------------------------------------------------\n");
//	fwrite($fh, implode(",",$fieldNamesList));

//	fclose($fh);
	
	// Free resultset
	pg_free_result($result);
	
	// Closing connection
	pg_close($dbconn);
	return array($rowList,$fieldNamesList ,$idContainer);


	
}

function insertZoomLink($line,$oLayer,$oMap)
{
	
	
	$str = "<a href= \"javascript:{window.opener.Fusion.Widget.MyQueryWidget.prototype.customZoomTo(";															
	

	$locX=(float)$line["loc_x"];
	$locY=(float)$line["loc_y"];

	$mapProj = $oMap->getProjection();
	$layerProj = $oLayer->getProjection();

	if($mapProj <>$layerProj){
		$oPoint = ms_newpointObj();
		$oPoint->setXY($locX,$locY);
		$oPoint->project( ms_newprojectionobj($layerProj) , ms_newprojectionobj($mapProj));
	}


	$str.=$oPoint->x . "," . $oPoint->y . "," . $oPoint->x . "," . $oPoint->y;
	$str.=")}\">Zoom</a>";


	return $str;
}



if ( ($_REQUEST['layer'] != '') && ($_REQUEST['selectString'] != '') && ($_REQUEST['whereString'] != '') && ($_REQUEST['fromString'] != '') && ($_REQUEST['id_field'] != '') )  {
	$szLayer = $_REQUEST['layer'];
	$selectString = urldecode  ( $_REQUEST['selectString']);
	$whereString = urldecode  ( $_REQUEST['whereString']);
	$fromString = urldecode  ( $_REQUEST['fromString']);
	$field = urldecode  ( $_REQUEST['id_field']);
	$selectString .= ",loc_x, loc_y ";
	$file="query.txt";
	$fh = fopen($file, "w");
	
	$whereString = str_replace("\\","",$whereString);
	
	fwrite($fh, "SELECT $selectString FROM $fromString WHERE $whereString ");
	fclose($fh);
}
else 
{
     die('layer, attribute or value not set');
}

if (!isset($mapName)) {
     die('mapname not set');
}

if (isset($_SESSION['maps']) && isset($_SESSION['maps'][$mapName])) {
     $oMap = ms_newMapObj($_SESSION['maps'][$mapName]);
}

$oLayer = $oMap->GetLayerByName($szLayer);

list($resultTableArray, $resultFieldList, $idList) = getPgsqlResult($selectString, $fromString,$whereString,$oLayer,$oMap);

saveToExcel($resultTableArray, $resultFieldList);


if($oLayer->connectiontype == MS_POSTGIS)
{
	if(	substr($field, 0,4) =="well")
	{
		$field = "well_id";
	}
	$expression = $field . " = ANY (ARRAY[ ";
	if(count($idList) > 0 )
	{
		foreach($idList as $id) {	$expression .= "$id,"; }
	}
	$expression = substr($expression,0,-1) . "]::integer[])";
}



$result = NULL;
//$result->incomingquerystring = $szQueryString;
$result->hasSelection = false;
$result->layers = array();
$result->tableContents = $resultTableArray;
$result->fieldNameList = $resultFieldList;

$file="expression.txt";
$fh = fopen($file, "w");
fwrite($fh,"\n------------------------------------------------------------\n");
fwrite($fh, $expression);
fwrite($fh,"\n------------------------------------------------------------\n");
fwrite($fh, $field);
fwrite($fh,"\n------------------------------------------------------------\n");
fwrite($fh, $oLayer->name);

fclose($fh);


if ($oLayer->queryByAttributes($field,$expression, MS_MULTIPLE) == MS_SUCCESS)
{
	//$image=$oMap->drawQuery();
	$oMap->savequery(getSessionSavePath()."query.qy");
    $result->hasSelection = true;
    $layerName = $oLayer->name;
    array_push($result->layers, $layerName);
    $result->$layerName->featureCount = $oLayer->getNumResults();
	$result->queryFile = getSessionSavePath()."query.qy";

	
	$properties = NULL;
    $properties->layers = array();

    $totalminx = 0;
    $totalminy = 0;
    $totalmaxx = 0;
    $totalmaxy = 0;
    
    $bFirstElement = 1;
    $nLayers = $oMap->numlayers;
    for ($i=0; $i<$nLayers; $i++) { 
        $oLayer = $oMap->GetLayer($i);
        $numResults = $oLayer->getNumResults();
        if ($numResults == 0){
          continue;
        }
        $oLayer->open();
        $layerName = $oLayer->name != "" ? $oLayer->name : "Layer_".$i; 
        
        array_push($properties->layers, $layerName);
        $properties->$layerName->numelements = $numResults;

        $properties->$layerName->propertynames = array();
        $properties->$layerName->propertyvalues = array();
        $properties->$layerName->propertytypes = array();
        $properties->$layerName->values = array();

        $properties->$layerName->metadatanames= array();
        array_push($properties->$layerName->metadatanames, 'dimension');
        array_push($properties->$layerName->metadatanames, 'bbox');
        array_push($properties->$layerName->metadatanames, 'center');
        array_push($properties->$layerName->metadatanames, 'area');
        array_push($properties->$layerName->metadatanames, 'length');

        /*get first shape to get the attributes*/
        $oRes = $oLayer->getResult(0);
        $oShape = $oLayer->getShape($oRes->tileindex,$oRes->shapeindex);
        $selFields = array();
        
        if (isset($_SESSION[$mapName][$layerName]['query_items'])) {
            $aQueryItems = $_SESSION[$mapName][$layerName]['query_items'];
        } else {
            //token separator (for parsing displayed attributes on a query)
            $tokenSeparator = ","; 
            // checking if metadata "query_include_items" is set
            $metadataItems = $oLayer->getMetaData('query_include_items');
            if ( ($metadataItems == "") || ($metadataItems == "all") ) {
                while ( list($key,$val) = each($oShape->values) ) {
                    $aQueryItems[$key]  = NULL;
                }
            } else {
              $token = strtok($metadataItems, $tokenSeparator);
              while ($token !== false) {
                  $aQueryItems[trim($token)] = NULL;
                  $token = strtok($tokenSeparator);
              }
            }
          
            // checking if metadata "query_exclude_items" is set
            $metadataItems = $oLayer->getMetaData('query_exclude_items');
            if ($metadataItems != "") {
                $token = strtok($metadataItems, $tokenSeparator);
                while ($token !== false) {
                    if (array_key_exists($token, $aQueryItems)) {
                        unset($aQueryItems[$token]);
                    }
                    $token = strtok($tokenSeparator);
                }
            }
            
            // get all alias
            while ( list($key,$val) = each($aQueryItems) ) {
                $keyAlias = $oLayer->getMetaData("query_".$key."_alias");
                trim($keyAlias);
                if ($keyAlias != "") {
                    $aQueryItems[$key] = $keyAlias;
                }
            }
            $_SESSION[$mapName][$layerName]['query_items'] = $aQueryItems;
        }
        
        $oShape = $oLayer->getShape($oRes->tileindex,$oRes->shapeindex);
        while ( list($key,$val) = each($oShape->values) ) {
            if (array_key_exists($key, $aQueryItems)) {
                array_push($selFields, $key);

                //we check if an alias if provided
                if (isset($aQueryItems[$key]) && ($aQueryItems[$key] != "")){
                    $key = $aQueryItems[$key];
                }

                array_push($properties->$layerName->propertynames, $key);
                //TODO : we should define away to give alias to field names
                array_push($properties->$layerName->propertyvalues, $key);

                //TODO we do not know the types of the attributes in MS. Just output 0
                //we shouls possibly use OGR to get the attributes
                array_push($properties->$layerName->propertytypes, 0);
            }
        }
        
        for ($iRes=0; $iRes < $numResults; $iRes++) {
            $properties->$layerName->values[$iRes] = array();
            $properties->$layerName->metadata[$iRes] = array();

            $oRes = $oLayer->getResult($iRes);
            $oShape = $oLayer->getShape($oRes->tileindex,$oRes->shapeindex);
            //TODO : area, length and distance are not set
            $minx =  $oShape->bounds->minx;
            $miny =  $oShape->bounds->miny;
            $maxx =  $oShape->bounds->maxx;
            $maxy =  $oShape->bounds->maxy;

            if ($bFirstElement) {
                $bFirstElement = 0;
                $totalminx =  $minx;
                $totalminy =  $miny;
                $totalmaxx =  $maxx;
                $totalmaxy =  $maxy;
            } else {
                if ($totalminx > $minx) {
                    $totalminx = $minx;
                }
                if ($totalminy > $miny) {
                    $totalminy = $miny;
                }
                if ($totalmaxx < $maxx) {
                    $totalmaxx = $maxx;
                }
                if ($totalmaxy < $maxy) {
                    $totalmaxy = $maxy;
                }
            }

            //metadata : TODO dimension, area, length and distance are not set
            $dimension = 0;
            $center = 0;
            $area = 0;
            $length = 0;
            $bbox = $minx.','.$miny.','.$maxx.','.$maxy;

            array_push($properties->$layerName->metadata[$iRes], $dimension);
            array_push($properties->$layerName->metadata[$iRes], $bbox);
            array_push($properties->$layerName->metadata[$iRes], $center);
            array_push($properties->$layerName->metadata[$iRes], $area);
            array_push($properties->$layerName->metadata[$iRes], $length);

            //field values
            for($iField=0; $iField < count($selFields); $iField++) {
                $value = $oShape->values[$selFields[$iField]];
                //$value = preg_replace( "/\r?\n/", "<br>", $value );
                $value = str_replace("'", "\'", $value);
                array_push($properties->$layerName->values[$iRes], $value);
            }
        }

        $oLayer->close();
    }

    //extents
    $properties->extents = NULL;
    $properties->extents->minx = $totalminx;
    $properties->extents->miny = $totalminy;
    $properties->extents->maxx = $totalmaxx;
    $properties->extents->maxy = $totalmaxy;
    
    $_SESSION['selection_array'] = $properties; 
}

//$image_url=$image->saveWebImage();

header('Content-type: text/x-json');
header('X-JSON: true');


$file="result.txt";
$fh = fopen($file, "w");
fwrite($fh,"\n------------------------------------------------------------\n");
fwrite($fh, var2json($result));
fwrite($fh,"\n------------------------------------------------------------\n");
fclose($fh);


echo var2json($result);

//print_r($properties);

$error=ms_GetErrorObj();
while($error && $error->code!=MS_NOERR)
{
	//printf("Error in %s: %s\n",$error->routine,$error->message);
	$error=$error->next();
}

?>
